/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "content.h"
#include "../core/request.h"
#include "../core/data.h"





void Content::FunDownload()
{
	// !! moze wywalic to no_item i wszedzie w takich miejscach dac poprostu permission_denied?
	if( !request.is_item )
	{
		log << log1 << "Content: pv function requires an item" << logend;
		request.status = WINIX_ERR_NO_ITEM;
		return;
	}

	
	if( !request.HasReadAccess(request.item) ||
		request.item.auth == Item::auth_none ||
		data.auth_simplefs_dir.empty() )
	{
		request.status = WINIX_ERR_PERMISSION_DENIED;
		return;
	}

	request.send_as_attachment = request.IsParam("attachment");

	if( !request.MakePath(request.x_sendfile) )
	{
		request.status = WINIX_ERR_PERMISSION_DENIED;
		return;
	}
}




