/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "content.h"
#include "../core/request.h"
#include "../core/error.h"
#include "../core/notify.h"



void Content::FunReloadTemplates()
{
	log << log1 << "Content: reloading html templates" << logend;

	templates.ReadTemplates();
	notify.ReadTemplates(); // make sure that ReadTemplates() is using some kind of locking
}




void Content::FunReload()
{
	// !! temporarily only an admin has access
	
	if( !request.session->puser || !request.session->puser->super_user )
	{
		log << log1 << "Content: Only an admin has access to reload function" << logend;
		request.status = WINIX_ERR_PERMISSION_DENIED;
		return;
	}

	if( request.IsParam("templates") )
		FunReloadTemplates();
}




