/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucorecompress
#define headerfilecmslucorecompress

#include <cstring>
#include <fcgiapp.h>
#include <zlib.h>


class Compress
{

public:

	Compress();
	~Compress();

	int Init(int compress_level = 6);
	int CompressAndPut(const char * source, size_t source_len, FCGX_Stream * out_stream, int level = 6);
	size_t last_out_size;

private:

	bool AllocateMemory();
	int MakeCompress(const char * source, size_t source_len, FCGX_Stream * out_stream);

	size_t buffer_max_len;
	char * buffer;
	z_stream strm;
	bool ready_for_compress;

};


#endif
