/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucorepostparser
#define headerfilecmslucorepostparser

#include <fcgiapp.h>
#include <string>
#include "httpsimpleparser.h"
#include "requesttypes.h"




class PostParser : public HttpSimpleParser
{

	FCGX_Stream * in;
	PostTable & post_table;

protected:


	virtual int GetChar()
	{
		return FCGX_GetChar(in);
	}
	

	virtual void Parameter(std::string & name, std::string & value)
	{
		std::pair<PostTable::iterator, bool> res = post_table.insert( std::make_pair(name, value) );
				
		log << log2 << "Method POST, name: \"" << name << "\", value: \"" << value << "\"";
		
		if( res.second == false )
			log << log2 << " (skipped)";
			
		log << log2 << logend;
	}
	

public:

	PostParser(FCGX_Stream * in_, PostTable & post_table_) : in(in_), post_table(post_table_)
	{
	}

};


#endif
