/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslutemplatesckeditorgetparser
#define headerfilecmslutemplatesckeditorgetparser


#include <string>
#include "../core/httpsimpleparser.h"
#include "../core/log.h"




class CKEditorGetParser : public HttpSimpleParser
{
	const char * pchar;


protected:


	virtual int GetChar()
	{
		if( !pchar || *pchar == 0 )
			return -1;

	return (int)(unsigned char)*(pchar++);
	}
	

	virtual void Parameter(std::string & name, std::string & value)
	{
		if( name == "CKEditorFuncNum" )
		{
			fun_num = atol(value.c_str());
			log << log3 << "CKEGetParser: callback function number: " << fun_num << logend;
		}
	}	
	

public:

	long fun_num;

	CKEditorGetParser()
	{
		pchar    = 0;
		fun_num  = 0;
	}

	void Parse(const char * str)
	{
		pchar = str;
		HttpSimpleParser::Parse();
	}


};


#endif
