/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */


#include "../core/data.h"
#include "../core/misc.h"
#include "misc.h"


namespace TemplatesMisc
{


void print_date_nice(Ezc::Info & i, tm * ptm)
{
	time_t t       = mktime(ptm);
	time_t now     = time(0);
	time_t one_day = 60 * 60 * 24;

	if( t + one_day > now )
		i.out << DateToStr(ptm->tm_year + 1900, ptm->tm_mon + 1, ptm->tm_mday, ptm->tm_hour, ptm->tm_min, ptm->tm_sec);
	else
		i.out << DateToStr(ptm->tm_year + 1900, ptm->tm_mon + 1, ptm->tm_mday);
}






// those functions from here are used in the second thread too




void Read(Patterns & patterns, size_t pat, Locale & locale, LocaleFilter & locale_filter, const char * file, bool delete_white)
{
	size_t i;
	size_t len = patterns.size();
	Locale::Lang old_lang = locale.GetLang();
	

	for(i=0 ; i<len ; ++i)
	{
		if( pat < patterns[i].size() )
		{
			patterns[i][pat].delete_all_white = delete_white;
			patterns[i][pat].Directory(data.templates_dir, data.templates_dir_default);
			patterns[i][pat].ParseFile(file);

			Locale::Lang new_lang = static_cast<Locale::Lang>(i);
			locale.SetLang(new_lang);

			locale_filter.Filter(patterns[i][pat], locale);
		}
	}

	locale.SetLang(old_lang);










}



void ClearPatterns(Patterns & patterns, size_t len)
{
size_t loc, pat;

	patterns.resize(Locale::lang_unknown);

	for(loc=0 ; loc < static_cast<size_t>(Locale::lang_unknown) ; ++loc)
	{
		patterns[loc].resize(len);

		for(pat=0 ; pat<len ; ++pat)
			patterns[loc][pat].Clear();
	}
}


} // namespace TemplatesMisc


