/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "templates.h"
#include "../core/data.h"



namespace TemplatesFunctions
{




void mount_page_is(Info & i)
{
	if( !i.is )
		return;

	i.result = data.mounts.pmount->IsArg(Mount::par_page, *i.is);
}

void mount_thread_is(Info & i)
{
	if( !i.is )
		return;

	i.result = data.mounts.pmount->IsArg(Mount::par_thread, *i.is);
}


void mount_type_is_thread(Info & i)
{
	i.result = data.mounts.pmount->type == Mount::thread;
}


void mount_type_is_ticket(Info & i)
{
	i.result = data.mounts.pmount->type == Mount::ticket;
}


void mount_type_is_cms(Info & i)
{
	i.result = data.mounts.pmount->type == Mount::cms;	
}




} // namespace TemplatesFunctions



