/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "templates.h"
#include "../core/data.h"
#include "../core/request.h"
#include "../core/misc.h"




namespace TemplatesFunctions
{



void user_logged(Info & i)
{
	i.result = request.session->puser != 0;
}


void user_name(Info & i)
{
	if( !request.session->puser )
		return;
	
	HtmlEscape(i.out, request.session->puser->name);
}



void user_super_user(Info & i)
{
	if( request.session->puser && request.session->puser->super_user )
		i.result = true;
}


void user_can_use_html(Info & i)
{
	if( !request.session->puser )
		i.result = false;
	else
		i.result = request.CanUseHtml(request.session->puser->id);
}


void user_can_use_bbcode(Info & i)
{
	if( !request.session->puser )
		i.result = false;
	else
		i.result = request.CanUseBBCode(request.session->puser->id);
}


void user_can_use_raw(Info & i)
{
	if( !request.session->puser )
		i.result = false;
	else
		i.result = request.CanUseRaw(request.session->puser->id);
}



} // namespace TemplatesFunctions



